Subject: qdisc_restart locking bug?

From: Jeff Garzik <[email-masked]>
Date: Fri, 15 Nov 2002 14:01:22 -0500

When qdisc_restart() is called from qdisc_run(), dev->queue_lock is 
obtained via spin_lock_bh().

When dev->hard_start_xmit() is called from qdisc_restart(), 
dev->queue_lock is dropped, and then re-acquired using only spin_lock().

So, doesn't qdisc_restart need s/spin_lock/spin_lock_bh/ for 
dev->queue_lock?

When looking at the dev_queue_xmit -> qdisc_run -> qdisc_restart call 
path, it seems so to me.

	Jeff